/**********************************************************
 * WebMailFolder                                          *
 * All rights reserved                                    *
 * 1996/08/16   Norbert Kuemin   norbert.kuemin@lugs.ch   *
 **********************************************************/

#define MIME_FILE
#include "wmf.h"

int GetContentType(char *Zeile) {
    char *tmpstr;
    int n;
    
    if (config.DebugLevel & 1)
	printf(".GetContentType(%s)\n",Zeile);
    tmpstr = Zeile;
    /* Remove leading tabs and spaces */
    while (((tmpstr[0] == '\t') || (tmpstr[0] == ' ')) && (tmpstr[0] != '\0'))
	tmpstr++;
    tmpstr = dupchar(tmpstr);
    /* Convert to uppercase */
    for (n=0;n<strlen(tmpstr);n++) tmpstr[n] = toupper(tmpstr[n]);
    if (strncmp(tmpstr,"TEXT/PLAIN",10) == 0) {
	if (strstr(tmpstr,"US-ASCII") != NULL) return MIME_TYPE_USASCII;
	if (strstr(tmpstr,"ISO-8859-1") != NULL) return MIME_TYPE_88591;
    }
    if (strncmp(tmpstr,"MULTIPART/MIXED",15) == 0) return MIME_TYPE_MIXED;
    if (strncmp(tmpstr,"TEXT/HTML",9) == 0) return MIME_TYPE_HTML;
    if (strncmp(tmpstr,"APPLICATION/OCTET-STREAM",24) == 0) return MIME_TYPE_OCTSTREAM;
    fprintf(stderr,"warning: unknown mime type *%s*\n",tmpstr);
    return MIME_TYPE_UNKNOWN;
}

int GetContentEncode(char *Zeile) {
    char *tmpstr;
    int n;
    
    if (config.DebugLevel & 1)
	printf(".GetContentEncode(%s)\n",Zeile);
    tmpstr = Zeile;
    /* Remove leading tabs and spaces */
    while (((tmpstr[0] == '\t') || (tmpstr[0] == ' ')) && (tmpstr[0] != '\0'))
	tmpstr++;
    tmpstr = dupchar(tmpstr);
    /* Convert to uppercase */
    for (n=0;n<strlen(tmpstr);n++) tmpstr[n] = toupper(tmpstr[n]);
    if (strncmp(tmpstr,"7BIT",4) == 0) return MIME_ENCODE_7BIT;
    if (strncmp(tmpstr,"8BIT",4) == 0) return MIME_ENCODE_8BIT;
    if (strncmp(tmpstr,"QUOTED-PRINTABLE",16) == 0) return MIME_ENCODE_QUOTED;
    if (strncmp(tmpstr,"BASE64",6) == 0) return MIME_ENCODE_BASE64;
    fprintf(stderr,"warning: unknown mime encode *%s*\n",tmpstr);
    return MIME_ENCODE_UNKNOWN;
}

char *GetBoundary(char *Zeile) {
    char *tmpstr, *retstr;
    int n;
    
    if (config.DebugLevel & 1)
	printf(".GetBoundary(%s)\n",Zeile);
    tmpstr = strstr(Zeile,MIME_TEXT_BOUNDERY_START) +
	strlen(MIME_TEXT_BOUNDERY_START);
    n = strstr(tmpstr,MIME_TEXT_BOUNDERY_END) - tmpstr;
    retstr = newchar(n+1);
    retstr[0] = '\0';
    strncat(retstr,tmpstr,n);
    return retstr;
}

char *Quoted2Text(char *Zeile) {
    char *retstr, *tmpstr;
    int n;

    /* quoted printable will NEVER be greater then the original text */
    retstr = newchar(strlen(Zeile)+1);

    retstr[0] = '\0';
    tmpstr = Zeile;

    while (tmpstr[0] != '\0') {
	if (tmpstr[0] == '=') {
	    /* Coded characters beginn with a = */
	    if (tmpstr[1] == '\n') {
		tmpstr++;
		n = strlen(retstr) - 1;
		while ((retstr[n] != ' ') && (n > 0)) n--;
		if (n > 0) retstr[n] = '\n';
	    }
	    if (((tmpstr[1] >= '0') && (tmpstr[1] <= '9')) ||
		((tmpstr[1] >= 'A') && (tmpstr[1] <= 'F'))) {
		if (((tmpstr[2] >= '0') && (tmpstr[2] <= '9')) ||
		    ((tmpstr[2] >= 'A') && (tmpstr[2] <= 'F'))) {
		    retstr[strlen(retstr)+1] = '\0';
		    if (tmpstr[1] > '9')
			retstr[strlen(retstr)] = 16 * (tmpstr[1]-55);
		    else
			retstr[strlen(retstr)] = 16 * (tmpstr[1]-48);
		    if (tmpstr[2] > '9')
			retstr[strlen(retstr)-1] = retstr[strlen(retstr)-1] + (tmpstr[2]-55);
		    else
			retstr[strlen(retstr)-1] = retstr[strlen(retstr)-1] + (tmpstr[2]-48);
		    tmpstr++;
		    tmpstr++;
		}
	    }
	} else {
	    /* normal character */
	    retstr[strlen(retstr)+1] = '\0';
	    retstr[strlen(retstr)] = tmpstr[0];
	}
	tmpstr++;
    }
    return retstr;
}

char *Text2Html(char *Zeile) {
    char *retstr, *tmpstr;

    retstr = newchar(strlen(Zeile)*10);

    retstr[0] = '\0';
    tmpstr = Zeile;

    while (tmpstr[0] != '\0') {
	switch (tmpstr[0]) {
	    case '<':
		strcat(retstr,"&lt;");
		break;
	    case '>':
		strcat(retstr,"&gt;");
		break;
	    case '':
		strcat(retstr,"&auml;");
		break;
	    case '':
		strcat(retstr,"&ouml;");
		break;
	    case '':
		strcat(retstr,"&uuml;");
		break;
	    case '':
		strcat(retstr,"&Auml;");
		break;
	    case '':
		strcat(retstr,"&Ouml;");
		break;
	    case '':
		strcat(retstr,"&Uuml;");
		break;
	    case '':
		strcat(retstr,"&copy;");
		break;
	    default:
		retstr[strlen(retstr)+1] = '\0';
		retstr[strlen(retstr)] = tmpstr[0];
		break;
	}
	tmpstr++;
    }
    return retstr;
}
